package net.benwilcock.service.handlerchain;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.xml.ws.handler.MessageContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class BaseHandler<T extends MessageContext> {
	protected String HandlerName = null;

	private static Log log = LogFactory.getLog(BaseHandler.class);

	@PostConstruct
	public void init() {
		log.trace("------------------------------------");
		log.trace("In Handler " + HandlerName + ":init()");
		log.trace("Exiting Handler " + HandlerName + ":init()");
		log.trace("------------------------------------");
	}

	@PreDestroy
	public void destroy() {
		log.trace("------------------------------------");
		log.trace("In Handler " + HandlerName + ":destroy()");
		log.trace("Exiting Handler " + HandlerName + ":destroy()");
		log.trace("------------------------------------");
	}


	public boolean handleFault(T mc) {
		log.trace("------------------------------------");
		log.trace("In Handler " + HandlerName + ":handleFault()");
		log.trace("Exiting Handler " + HandlerName + ":handleFault()");
		log.trace("------------------------------------");
		return true;
	}
	
	public void close(MessageContext mc) {
		log.trace("------------------------------------");
		log.trace("In Handler " + HandlerName + ":close()");
		log.trace("Exiting Handler " + HandlerName + ":close()");
		log.trace("------------------------------------");
	}

	public void setHandlerName(String handlerName) {
		HandlerName = handlerName;
	}
	
}
