package net.benwilcock.service.handlerchain;

import java.io.PrintStream;
import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/*
 * Log the whole SOAP message
 */
public class EnvelopeLoggingSOAPHandler extends BaseHandler<SOAPMessageContext> implements SOAPHandler<SOAPMessageContext> {
    
	private static Log log = LogFactory.getLog(EnvelopeLoggingSOAPHandler.class);
	private static final String HANDLER_NAME = "EnvelopeLoggingSOAPHandler";
     
    public EnvelopeLoggingSOAPHandler(){
		super();
		super.setHandlerName(HANDLER_NAME);		
    }
    
    public boolean handleMessage(SOAPMessageContext smc) {
		log.trace("------------------------------------");
		log.trace("In SOAPHandler " + HandlerName + ":handleMessage()");
		logToSystemOut(smc);
		log.trace("Exiting SOAPHandler " + HandlerName + ":handleMessage()");
		log.trace("------------------------------------");    	
        return true;
    }

    private void logToSystemOut(SOAPMessageContext smc) {
        Boolean outboundProperty = (Boolean)
            smc.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        
        if (outboundProperty.booleanValue()) {
            log.trace("\ndirection = outbound ");
        } else {
            log.trace("\ndirection = inbound ");
        }
        
        SOAPMessage message = smc.getMessage();
        try {
        	log.trace("");   
        	log.trace(message.toString());
            log.trace("");   
        } catch (Exception e) {
            log.trace("Exception in SOAP Handler #1: " + e);
        }
    }

	public Set<QName> getHeaders() {
		return null;
	}
}
