package net.benwilcock.service.handlerchain;

import javax.xml.transform.Source;
import javax.xml.ws.LogicalMessage;
import javax.xml.ws.handler.LogicalHandler;
import javax.xml.ws.handler.LogicalMessageContext;
import javax.xml.ws.handler.MessageContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * The payload using Source class from JAXP.
 */
public class JAXPPayloadLoggingLogicalHandler extends
		BaseHandler<LogicalMessageContext> implements
		LogicalHandler<LogicalMessageContext> {
	private static Log log = LogFactory.getLog(JAXPPayloadLoggingLogicalHandler.class);

	private static final String HANDLER_NAME = "JAXPPayloadLoggingLogicalHandler";

	public JAXPPayloadLoggingLogicalHandler() {
		super();
		super.setHandlerName(HANDLER_NAME);
	}

	public boolean handleMessage(LogicalMessageContext smc) {
		log.debug("------------------------------------");
		log.debug("In LogicalHandler " + HandlerName + ":handleMessage()");

		logToSystemOut(smc);

		log.debug("Exiting LogicalHandler " + HandlerName
				+ ":handleMessage()");
		log.debug("------------------------------------");

		return true;
	}

	private void logToSystemOut(LogicalMessageContext smc) {
		Boolean outboundProperty = (Boolean) smc
				.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

		if (outboundProperty.booleanValue()) {
			log.debug("\ndirection = outbound ");
		} else {
			log.debug("\ndirection = inbound ");
		}

		LogicalMessage message = smc.getMessage();

		try {
			Source src = message.getPayload();
			log.debug(HandlerUtil.getXMLFromSource(src));
		} catch (Exception e) {
			log.debug("Exception in " + HandlerName + ":" + e);
		}
	}

}
