package net.benwilcock.service.handlerchain;

import java.util.Date;
import java.util.logging.Logger;

import javax.xml.ws.handler.LogicalHandler;
import javax.xml.ws.handler.LogicalMessageContext;
import javax.xml.ws.handler.MessageContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ServicePerformanceMonitorLogicalHandler extends
		BaseHandler<LogicalMessageContext> implements
		LogicalHandler<LogicalMessageContext> {
	private static final String HANDLER_NAME = "ServicePerformanceMonitorLogicalHandler";

	private final static Logger log = Logger.getLogger("ServicePerformanceMonitorLogicalHandler");

	Date startTime, endTime;

	public ServicePerformanceMonitorLogicalHandler() {
		super();
		super.setHandlerName(HANDLER_NAME);
	}

	public boolean handleMessage(LogicalMessageContext smc) {
		Boolean outboundProperty = (Boolean) smc
				.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

		log.fine("------------------------------------");
		log.fine("In LogicalHandler " + HandlerName + ":handleMessage()");

		if (outboundProperty.booleanValue()) {
			log.fine("\ndirection = outbound ");
			try {
				startTime = (Date) smc.get(HandlerName + "StartTime");
				endTime = new Date();
				long elapsedTime = endTime.getTime() - startTime.getTime();
				log.fine("");
				log.fine("Elapsed time in handler " + HandlerName + " is "
						+ elapsedTime);
				log.fine("");
			} catch (Exception x) {
				x.printStackTrace();
			}
		} else {
			startTime = new Date();
			smc.put(HandlerName + "StartTime", startTime);
		}
		log.fine("Exiting LogicalHandler " + HandlerName
				+ ":handleMessage()");
		log.fine("------------------------------------");
		return true;
	}
}